﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class CaseHeaderHtml : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["Data"] == null)
        {
            Griddata data = new Griddata();
            Session["Data"] = data.Items;
        }

        GrdMain.DataSource = Session["Data"];
        GrdMain.DataBind();
        generatePager(500, GrdMain.PageSize, 1);

    }

    public void generatePager(long totalRowCount, int pageSize, int currentPage)
    {

        //here totalRowCount is above 180 records
        int totalLinkInPage = 10;
        bool flag = false;
        int j = 0;
        int newpage;

        int totalPageCount = (int)Math.Ceiling((decimal)totalRowCount / pageSize);

        int startPageLink = Math.Max(currentPage - (int)Math.Floor((decimal)totalLinkInPage / 2), 1);
        int lastPageLink = Math.Min(startPageLink + totalLinkInPage - 1, totalPageCount);

        if ((startPageLink + totalLinkInPage - 1) > totalPageCount)
        {
            lastPageLink = Math.Min(currentPage + (int)Math.Floor((decimal)totalLinkInPage / 2), totalPageCount);
            startPageLink = Math.Max(lastPageLink - totalLinkInPage + 1, 1);
        }

        if (totalRowCount > pageSize)
        {
            List<string> pageLinkContainer = new List<string>();

            if (currentPage == 0)
                currentPage = 1;
            if (startPageLink != 1)
                pageLinkContainer.Add("First");
            if (currentPage > 10)
                pageLinkContainer.Add("<<");

            float i = (float)currentPage;
            float t = i / 10;
            if (t == (float)Math.Floor((decimal)(currentPage / 10)))
                newpage = (Convert.ToInt32(Math.Floor((decimal)((i - 1) / 10))) * 10) + 1;
            else
                newpage = (Convert.ToInt32(Math.Floor((decimal)(i / 10))) * 10) + 1;

            for (int temp = newpage; temp <= totalPageCount; temp++)
            {
                if (j < 10)
                {
                    pageLinkContainer.Add(temp.ToString());
                    j++;
                    if (temp == totalPageCount)
                    {
                        flag = true;
                        break;
                    }
                }
                else
                    break;
            }


            if (flag == false)
            {
                pageLinkContainer.Add(">>");
                pageLinkContainer.Add("Last");
            }

            dlPager.DataSource = pageLinkContainer;
            dlPager.DataBind();
        }
    }

    private void button1_Click(object sender, EventArgs e)
    {
        //using (var exporter = new UltraGridDocumentExporter())
        //{
        //    exporter.Export(ultraGrid1, "C:\\Test\\WinGrid_Report.pdf", GridExportFileFormat.PDF);
        //}

        if (txtFileName.Text != "")
        {
            string fileName = HttpUtility.UrlEncode(this.txtFileName.Text); // get filename
            fileName = fileName.Replace("+", "%20"); // format filename
            WebDocumentExporter1.DownloadName = fileName; // setting name of file that will be saved
            WebDocumentExporter1.Format = Infragistics.Web.UI.GridControls.FileFormat.PDF; // seting type of the document
            // setting export mode - to export all data in grid
            WebDocumentExporter1.DataExportMode = Infragistics.Web.UI.GridControls.DataExportMode.AllDataInDataSource;
            WebDocumentExporter1.TargetPaperSize = PageSizes.A4; // sets size of the exported page
           WebDocumentExporter1.Export(); 
        }
    }

}